DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Tree View - Plain Data Structure

The JavaScript TreeView's plain (one-dimensional) array contains items each of which references its parent item.

Backend API
$(() => { $('#simple-treeview').dxTreeView({ items: products, dataStructure: 'plain', parentIdExpr: 'categoryId', keyExpr: 'ID', displayExpr: 'name', width: 300, onItemClick(e) { const item = e.itemData; if (item.price) { $('#product-details').removeClass('hidden'); $('#product-details > img').attr('alt', item.name).attr('src', item.icon); $('#product-details > .price').text(`$${item.price}`); $('#product-details > .name').text(item.name); } else { $('#product-details').addClass('hidden'); } }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.3"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="form"> <div id="simple-treeview"></div> <div id="product-details" class="hidden"> <img alt="Product details" src="" /> <div class="name"></div> <div class="price"></div> </div> </div> </div> </body> </html>
#simple-treeview, #product-details { display: inline-block; } #product-details { vertical-align: top; width: 400px; height: 420px; margin-left: 20px; } #product-details > img { border: none; height: 300px; width: 400px; } #product-details > .name { text-align: center; font-size: 20px; } #product-details > .price { text-align: center; font-size: 24px; } .dark #product-details > div { color: #f0f0f0; } .hidden { visibility: hidden; }
const products = [{ ID: '1', name: 'Stores', expanded: true, }, { ID: '1_1', categoryId: '1', name: 'Super Mart of the West', expanded: true, }, { ID: '1_1_1', categoryId: '1_1', name: 'Video Players', }, { ID: '1_1_1_1', categoryId: '1_1_1', name: 'HD Video Player', icon: '../../../../images/products/1.png', price: 220, }, { ID: '1_1_1_2', categoryId: '1_1_1', name: 'SuperHD Video Player', icon: '../../../../images/products/2.png', price: 270, }, { ID: '1_1_2', categoryId: '1_1', name: 'Televisions', expanded: true, }, { ID: '1_1_2_1', categoryId: '1_1_2', name: 'SuperLCD 42', icon: '../../../../images/products/7.png', price: 1200, }, { ID: '1_1_2_2', categoryId: '1_1_2', name: 'SuperLED 42', icon: '../../../../images/products/5.png', price: 1450, }, { ID: '1_1_2_3', categoryId: '1_1_2', name: 'SuperLED 50', icon: '../../../../images/products/4.png', price: 1600, }, { ID: '1_1_2_4', categoryId: '1_1_2', name: 'SuperLCD 55', icon: '../../../../images/products/6.png', price: 1750, }, { ID: '1_1_2_5', categoryId: '1_1_2', name: 'SuperLCD 70', icon: '../../../../images/products/9.png', price: 4000, }, { ID: '1_1_3', categoryId: '1_1', name: 'Monitors', }, { ID: '1_1_3_1', categoryId: '1_1_3', name: '19"', }, { ID: '1_1_3_1_1', categoryId: '1_1_3_1', name: 'DesktopLCD 19', icon: '../../../../images/products/10.png', price: 160, }, { ID: '1_1_4', categoryId: '1_1', name: 'Projectors', }, { ID: '1_1_4_1', categoryId: '1_1_4', name: 'Projector Plus', icon: '../../../../images/products/14.png', price: 550, }, { ID: '1_1_4_2', categoryId: '1_1_4', name: 'Projector PlusHD', icon: '../../../../images/products/15.png', price: 750, }, ];

Use either of the following properties to bind the component to plain data:

  • items[]
    Assigns a local array as shown in this demo.

  • dataSource
    Assigns a DataSource object that allows you to perform data shaping operations and use a remote source.

Each object in the JavaScript TreeView's plain data structure should include the following fields:

  • id
    Unique item identifier.

  • parentId
    Identifier of the parent item.

  • text
    Text displayed by the item.

You can respectively use the keyExpr, parentIdExpr, and displayExpr properties to specify custom names for the above-mentioned fields. Node objects can also include developer-defined fields and properties from this help section: items[].

In this demo, nodes use the icon and expanded properties. These properties specify the icon and whether a node is collapsed or expanded. Some nodes also include the developer-defined price field.

<div class="form">
<dx-tree-view
id="simple-treeview"
[items]="products"
dataStructure="plain"
parentIdExpr="categoryId"
keyExpr="ID"
displayExpr="name"
[width]="300"
(onItemClick)="selectItem($event)"
></dx-tree-view>
<div id="product-details" *ngIf="currentItem.price">
<img [src]="currentItem.icon" />
<div class="name">{{currentItem.name}}</div>
<div class="price">{{"$" + currentItem.price}}</div>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxTreeViewModule } from 'devextreme-angular';
import { Product, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
products: Product[];
currentItem: Product;
constructor(service: Service) {
this.products = service.getProducts();
this.currentItem = this.products[0];
}
selectItem(e) {
this.currentItem = e.itemData;
}
}
@NgModule({
imports: [
BrowserModule,
DxTreeViewModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #simple-treeview, #product-details {
display: inline-block;
}
::ng-deep #product-details {
vertical-align: top;
width: 400px;
height: 420px;
margin-left: 20px;
}
::ng-deep #product-details > img {
border: none;
height: 300px;
width: 400px;
}
::ng-deep #product-details > .name {
text-align: center;
font-size: 20px;
}
::ng-deep #product-details > .price {
text-align: center;
font-size: 24px;
}
::ng-deep .dark #product-details > div {
color: #f0f0f0;
}
::ng-deep .hidden {
visibility: hidden;
}
import { Injectable } from '@angular/core';
export class Product {
ID: string;
name: string;
expanded?: boolean;
categoryId?: string;
icon?: string;
price?: number;
}
var products: Product[] = [
{
ID: "1",
name: "Stores",
expanded: true
}, {
ID: "1_1",
categoryId: "1",
name: "Super Mart of the West",
expanded: true
}, {
ID: "1_1_1",
categoryId: "1_1",
name: "Video Players"
}, {
ID: "1_1_1_1",
categoryId: "1_1_1",
name: "HD Video Player",
icon: "../../../../images/products/1.png",
price: 220
}, {
ID: "1_1_1_2",
categoryId: "1_1_1",
name: "SuperHD Video Player",
icon: "../../../../images/products/2.png",
price: 270
}, {
ID: "1_1_2",
categoryId: "1_1",
name: "Televisions",
expanded: true
}, {
ID: "1_1_2_1",
categoryId: "1_1_2",
name: "SuperLCD 42",
icon: "../../../../images/products/7.png",
price: 1200
}, {
ID: "1_1_2_2",
categoryId: "1_1_2",
name: "SuperLED 42",
icon: "../../../../images/products/5.png",
price: 1450
}, {
ID: "1_1_2_3",
categoryId: "1_1_2",
name: "SuperLED 50",
icon: "../../../../images/products/4.png",
price: 1600
}, {
ID: "1_1_2_4",
categoryId: "1_1_2",
name: "SuperLCD 55",
icon: "../../../../images/products/6.png",
price: 1750
}, {
ID: "1_1_2_5",
categoryId: "1_1_2",
name: "SuperLCD 70",
icon: "../../../../images/products/9.png",
price: 4000
}, {
ID: "1_1_3",
categoryId: "1_1",
name: "Monitors"
}, {
ID: "1_1_3_1",
categoryId: "1_1_3",
name: "19\"",
}, {
ID: "1_1_3_1_1",
categoryId: "1_1_3_1",
name: "DesktopLCD 19",
icon: "../../../../images/products/10.png",
price: 160
}, {
ID: "1_1_4",
categoryId: "1_1",
name: "Projectors"
}, {
ID: "1_1_4_1",
categoryId: "1_1_4",
name: "Projector Plus",
icon: "../../../../images/products/14.png",
price: 550
}, {
ID: "1_1_4_2",
categoryId: "1_1_4",
name: "Projector PlusHD",
icon: "../../../../images/products/15.png",
price: 750
}
];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24',
'devextreme-angular': 'npm:devextreme-angular@20.2.6',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Plain Data Structure

Documentation

The TreeView's plain (one-dimensional) array contains items each of which references its parent item. Use either of the following properties to bind the component to plain data:

  • items[]
    Assigns a local array as shown in this demo.

  • dataSource
    Assigns a DataSource object that allows you to perform data shaping operations and use a remote source.

Each object in the TreeView's plain data structure should include the following fields:

  • id
    Unique item identifier.

  • parentId
    Identifier of the parent item.

  • text
    Text displayed by the item.

You can respectively use the keyExpr, parentIdExpr, and displayExpr properties to specify custom names for the above-mentioned fields. Node objects can also include developer-defined fields and properties from this help section: items[].

In this demo, nodes use the icon and expanded properties. These properties specify the icon and whether a node is collapsed or expanded. Some nodes also include the developer-defined price field.

Backend API
import React, { useCallback, useState } from 'react'; import TreeView, { TreeViewTypes } from 'devextreme-react/tree-view'; import service, { ProductType } from './data.ts'; const products = service.getProducts(); const App = () => { const [currentItem, setCurrentItem] = useState(products[0]); const selectItem = useCallback((e: TreeViewTypes.ItemClickEvent & { itemData: ProductType }) => { setCurrentItem({ ...e.itemData }); }, [setCurrentItem]); return ( <div className="form"> <TreeView id="simple-treeview" items={products} dataStructure="plain" displayExpr="name" parentIdExpr="categoryId" keyExpr="ID" width={300} onItemClick={selectItem} /> {currentItem.price && ( <div id="product-details"> <img alt={currentItem.name} src={currentItem.icon} /> <div className="name">{currentItem.name}</div> <div className="price">{`$${currentItem.price}`}</div> </div> )} </div> ); }; export default App;
import React, { useCallback, useState } from 'react'; import TreeView from 'devextreme-react/tree-view'; import service from './data.js'; const products = service.getProducts(); const App = () => { const [currentItem, setCurrentItem] = useState(products[0]); const selectItem = useCallback( (e) => { setCurrentItem({ ...e.itemData }); }, [setCurrentItem], ); return ( <div className="form"> <TreeView id="simple-treeview" items={products} dataStructure="plain" displayExpr="name" parentIdExpr="categoryId" keyExpr="ID" width={300} onItemClick={selectItem} /> {currentItem.price && ( <div id="product-details"> <img alt={currentItem.name} src={currentItem.icon} /> <div className="name">{currentItem.name}</div> <div className="price">{`$${currentItem.price}`}</div> </div> )} </div> ); }; export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
const products = [{ ID: '1', name: 'Stores', expanded: true, }, { ID: '1_1', categoryId: '1', name: 'Super Mart of the West', expanded: true, }, { ID: '1_1_1', categoryId: '1_1', name: 'Video Players', }, { ID: '1_1_1_1', categoryId: '1_1_1', name: 'HD Video Player', icon: '../../../../images/products/1.png', price: 220, }, { ID: '1_1_1_2', categoryId: '1_1_1', name: 'SuperHD Video Player', icon: '../../../../images/products/2.png', price: 270, }, { ID: '1_1_2', categoryId: '1_1', name: 'Televisions', expanded: true, }, { ID: '1_1_2_1', categoryId: '1_1_2', name: 'SuperLCD 42', icon: '../../../../images/products/7.png', price: 1200, }, { ID: '1_1_2_2', categoryId: '1_1_2', name: 'SuperLED 42', icon: '../../../../images/products/5.png', price: 1450, }, { ID: '1_1_2_3', categoryId: '1_1_2', name: 'SuperLED 50', icon: '../../../../images/products/4.png', price: 1600, }, { ID: '1_1_2_4', categoryId: '1_1_2', name: 'SuperLCD 55', icon: '../../../../images/products/6.png', price: 1750, }, { ID: '1_1_2_5', categoryId: '1_1_2', name: 'SuperLCD 70', icon: '../../../../images/products/9.png', price: 4000, }, { ID: '1_1_3', categoryId: '1_1', name: 'Monitors', }, { ID: '1_1_3_1', categoryId: '1_1_3', name: '19"', }, { ID: '1_1_3_1_1', categoryId: '1_1_3_1', name: 'DesktopLCD 19', icon: '../../../../images/products/10.png', price: 160, }, { ID: '1_1_4', categoryId: '1_1', name: 'Projectors', }, { ID: '1_1_4_1', categoryId: '1_1_4', name: 'Projector Plus', icon: '../../../../images/products/14.png', price: 550, }, { ID: '1_1_4_2', categoryId: '1_1_4', name: 'Projector PlusHD', icon: '../../../../images/products/15.png', price: 750, }, ]; export interface ProductType { ID: string, categoryId?: string, name: string, icon?: string, expanded?: boolean, price?: number } export default { getProducts(): ProductType[] { return products; }, };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme-react': 'npm:devextreme-react@23.2.5/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: '', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
const products = [ { ID: '1', name: 'Stores', expanded: true, }, { ID: '1_1', categoryId: '1', name: 'Super Mart of the West', expanded: true, }, { ID: '1_1_1', categoryId: '1_1', name: 'Video Players', }, { ID: '1_1_1_1', categoryId: '1_1_1', name: 'HD Video Player', icon: '../../../../images/products/1.png', price: 220, }, { ID: '1_1_1_2', categoryId: '1_1_1', name: 'SuperHD Video Player', icon: '../../../../images/products/2.png', price: 270, }, { ID: '1_1_2', categoryId: '1_1', name: 'Televisions', expanded: true, }, { ID: '1_1_2_1', categoryId: '1_1_2', name: 'SuperLCD 42', icon: '../../../../images/products/7.png', price: 1200, }, { ID: '1_1_2_2', categoryId: '1_1_2', name: 'SuperLED 42', icon: '../../../../images/products/5.png', price: 1450, }, { ID: '1_1_2_3', categoryId: '1_1_2', name: 'SuperLED 50', icon: '../../../../images/products/4.png', price: 1600, }, { ID: '1_1_2_4', categoryId: '1_1_2', name: 'SuperLCD 55', icon: '../../../../images/products/6.png', price: 1750, }, { ID: '1_1_2_5', categoryId: '1_1_2', name: 'SuperLCD 70', icon: '../../../../images/products/9.png', price: 4000, }, { ID: '1_1_3', categoryId: '1_1', name: 'Monitors', }, { ID: '1_1_3_1', categoryId: '1_1_3', name: '19"', }, { ID: '1_1_3_1_1', categoryId: '1_1_3_1', name: 'DesktopLCD 19', icon: '../../../../images/products/10.png', price: 160, }, { ID: '1_1_4', categoryId: '1_1', name: 'Projectors', }, { ID: '1_1_4_1', categoryId: '1_1_4', name: 'Projector Plus', icon: '../../../../images/products/14.png', price: 550, }, { ID: '1_1_4_2', categoryId: '1_1_4', name: 'Projector PlusHD', icon: '../../../../images/products/15.png', price: 750, }, ]; export default { getProducts() { return products; }, };
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#simple-treeview, #product-details { display: inline-block; } #product-details { vertical-align: top; width: 400px; height: 420px; margin-left: 20px; } #product-details > img { border: none; height: 300px; width: 400px; } #product-details > .name { text-align: center; font-size: 20px; } #product-details > .price { text-align: center; font-size: 24px; } .dark #product-details > div { color: #f0f0f0; } .hidden { visibility: hidden; }

<template>
<div class="form">
<DxTreeView
id="simple-treeview"
:items="products"
:width="300"
data-structure="plain"
parent-id-expr="categoryId"
key-expr="ID"
display-expr="name"
@item-click="selectItem"
/>
<div
v-if="currentItem.price"
id="product-details"
>
<img :src="currentItem.icon">
<div class="name">{{ currentItem.name }}</div>
<div class="price">{{ "$" + currentItem.price }}</div>
</div>
</div>
</template>
<script>
import DxTreeView from 'devextreme-vue/tree-view';
import service from './data.js';
export default {
components: {
DxTreeView
},
data() {
const products = service.getProducts();
return {
products,
currentItem: products[0]
};
},
methods: {
selectItem(e) {
this.currentItem = e.itemData;
}
}
};
</script>
<style scoped>
#simple-treeview, #product-details {
display: inline-block;
}
#product-details {
vertical-align: top;
width: 400px;
height: 420px;
margin-left: 20px;
}
#product-details > img {
border: none;
height: 300px;
width: 400px;
}
#product-details > .name {
text-align: center;
font-size: 20px;
}
#product-details > .price {
text-align: center;
font-size: 24px;
}
.dark #product-details > div {
color: #f0f0f0;
}
.hidden {
visibility: hidden;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
const products = [{
ID: '1',
name: 'Stores',
expanded: true
}, {
ID: '1_1',
categoryId: '1',
name: 'Super Mart of the West',
expanded: true
}, {
ID: '1_1_1',
categoryId: '1_1',
name: 'Video Players'
}, {
ID: '1_1_1_1',
categoryId: '1_1_1',
name: 'HD Video Player',
icon: '../../../../images/products/1.png',
price: 220
}, {
ID: '1_1_1_2',
categoryId: '1_1_1',
name: 'SuperHD Video Player',
icon: '../../../../images/products/2.png',
price: 270
}, {
ID: '1_1_2',
categoryId: '1_1',
name: 'Televisions',
expanded: true
}, {
ID: '1_1_2_1',
categoryId: '1_1_2',
name: 'SuperLCD 42',
icon: '../../../../images/products/7.png',
price: 1200
}, {
ID: '1_1_2_2',
categoryId: '1_1_2',
name: 'SuperLED 42',
icon: '../../../../images/products/5.png',
price: 1450
}, {
ID: '1_1_2_3',
categoryId: '1_1_2',
name: 'SuperLED 50',
icon: '../../../../images/products/4.png',
price: 1600
}, {
ID: '1_1_2_4',
categoryId: '1_1_2',
name: 'SuperLCD 55',
icon: '../../../../images/products/6.png',
price: 1750
}, {
ID: '1_1_2_5',
categoryId: '1_1_2',
name: 'SuperLCD 70',
icon: '../../../../images/products/9.png',
price: 4000
}, {
ID: '1_1_3',
categoryId: '1_1',
name: 'Monitors'
}, {
ID: '1_1_3_1',
categoryId: '1_1_3',
name: '19"',
}, {
ID: '1_1_3_1_1',
categoryId: '1_1_3_1',
name: 'DesktopLCD 19',
icon: '../../../../images/products/10.png',
price: 160
}, {
ID: '1_1_4',
categoryId: '1_1',
name: 'Projectors'
}, {
ID: '1_1_4_1',
categoryId: '1_1_4',
name: 'Projector Plus',
icon: '../../../../images/products/14.png',
price: 550
}, {
ID: '1_1_4_2',
categoryId: '1_1_4',
name: 'Projector PlusHD',
icon: '../../../../images/products/15.png',
price: 750
}
];
export default {
getProducts() {
return products;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'devextreme-vue': 'npm:devextreme-vue@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});